<?php
/**
* Class to create repeating settings fields
*/
class pmBiweRepeaterFields
{
	function __construct($screen_options, $animopts)
	{
		$this->screen_options = $screen_options;
		$this->animopts = $animopts;
	}

	public function settings_fields() {
		if( empty( $this->screen_options ) ) {
			$this->settings_fields_html( '1', '' );
		} else {
			foreach ($this->screen_options as $scrn_key => $svalue) {
				$this->settings_fields_html( $scrn_key + 1, $svalue );
			}
			$add_key = count($this->screen_options) + 1;
			$this->settings_fields_html( $add_key, '' );
		}
	}

	private function settings_fields_html($scrn_key, $svalue) {
		$name = isset( $svalue['name'] ) ? esc_attr( $svalue['name'] ) : '' ;
		$ar_code = isset( $svalue['ar_code'] ) ? esc_textarea( $svalue['ar_code'] ) : '' ;
		$ar_name = isset( $svalue['ar_name'] ) ? esc_attr( $svalue['ar_name'] ) : '' ;
		$ar_email = isset( $svalue['ar_email'] ) ? esc_attr( $svalue['ar_email'] ) : '' ;
		$ar_url = isset( $svalue['ar_url'] ) ? esc_attr( $svalue['ar_url'] ) : '' ;
		$ar_hidden = isset( $svalue['ar_hidden'] ) ? esc_textarea( $svalue['ar_hidden'] ) : '' ;
		$ar_name_label = isset( $svalue['ar_name_label'] ) ? esc_attr( $svalue['ar_name_label'] ) : '' ;
		$ar_email_label = isset( $svalue['ar_email_label'] ) ? esc_attr( $svalue['ar_email_label'] ) : '' ;
		$ar_button_label = isset( $svalue['ar_button_label'] ) ? esc_attr( $svalue['ar_button_label'] ) : '' ;
		$bgc = isset( $svalue['bgc'] ) ? esc_attr( $svalue['bgc'] ) : '' ;
		$txtc = isset( $svalue['txtc'] ) ? esc_attr( $svalue['txtc'] ) : '' ;
		$btnc = isset( $svalue['btnc'] ) ? esc_attr( $svalue['btnc'] ) : '' ;
		$anim = isset( $svalue['anim'] ) ? esc_attr( $svalue['anim'] ) : '' ;
		$content = isset( $svalue['content'] ) ? stripslashes( $svalue['content'] ) : '' ;
		$home = isset( $svalue['home'] ) ? esc_attr( $svalue['home'] ) : '' ;
		$cookie = isset( $svalue['cookie'] ) ? esc_attr( $svalue['cookie'] ) : '' ;
		?>
		<li id="scrn-<?php echo $scrn_key; ?>" class="screen">
			<div class="item hdr"><span><?php _e('Screen ID', 'pm-big-welcome'); ?>: <?php echo $scrn_key; ?></span> <?php submit_button('Save and Add', 'secondary', 'submit', false); ?> <button class="remove button button-secondary"><?php _e('Remove', 'pm-big-welcome'); ?></button></div>
			<div class="item col options">
				<div class="scrnname">
					<h3><?php _e('Name', 'pm-big-welcome'); ?></h3>
					<input type="text" name="pm_biwe_options[screen][name][]" class="regular-text" value="<?php echo $name; ?>"><br><small><?php _e('For your reference only. Not displayed to visitors.', 'pm-big-welcome'); ?></small>
				</div>
				<div class="optin">
					<h3><?php _e('Opt-in Form Code', 'pm-big-welcome'); ?></h3>
					<textarea id="ar_code-<?php echo $scrn_key; ?>" class="ar_code" name="pm_biwe_options[screen][ar_code][]" cols="50" rows="5"><?php echo $ar_code; ?></textarea><br>
					<small><?php printf( __( 'If your optin form doesn\'t work as expected, %1$s %2$s %3$s view autoresponder code%4$s to check.', 'pm-big-welcome' ), '<a href="#ar_advance" ', 'id="viewarcode-'.$scrn_key.'"', ' class="viewarcode">', '</a>' ); ?></small>
					<div id="arcode_hdn_div-<?php echo $scrn_key; ?>" class="arcode_hdn_div"></div>
					<div id="ar_advance-<?php echo $scrn_key; ?>" class="ar_advance">
						<label><?php _e('Optin form name field', 'pm-big-welcome'); ?></label>
						<input type="text" id="ar_name-<?php echo $scrn_key; ?>" class="ar_name" name="pm_biwe_options[screen][ar_name][]" value="<?php echo $ar_name; ?>">

						<label><?php _e('Optin form email field', 'pm-big-welcome'); ?></label>
						<input type="text" id="ar_email-<?php echo $scrn_key; ?>" class="ar_email" name="pm_biwe_options[screen][ar_email][]" value="<?php echo $ar_email; ?>">

						<label><?php _e('Optin form URL', 'pm-big-welcome'); ?></label>
						<input type="text" id="ar_url-<?php echo $scrn_key; ?>" class="ar_url" name="pm_biwe_options[screen][ar_url][]" value="<?php echo $ar_url; ?>">

						<label><?php _e('Optin form hidden fields', 'pm-big-welcome'); ?></label>
						<textarea id="ar_hidden-<?php echo $scrn_key; ?>" class="ar_hidden" name="pm_biwe_options[screen][ar_hidden][]"><?php echo $ar_hidden; ?></textarea>
						</td>
					</div>
					<label><?php _e('Name label', 'pm-big-welcome'); ?>
					<input type="text" id="ar_name_label-<?php echo $scrn_key; ?>" class="ar_name_label regular-text" name="pm_biwe_options[screen][ar_name_label][]" value="<?php echo $ar_name_label; ?>"></label>
					<label><?php _e('Email label', 'pm-big-welcome'); ?>
					<input type="text" id="ar_email_label-<?php echo $scrn_key; ?>" class="ar_email_label regular-text" name="pm_biwe_options[screen][ar_email_label][]" value="<?php echo $ar_email_label; ?>"></label>
					<label><?php _e('Button label', 'pm-big-welcome'); ?>
					<input type="text" id="ar_button_label-<?php echo $scrn_key; ?>" class="ar_button_label regular-text" name="pm_biwe_options[screen][ar_button_label][]" value="<?php echo $ar_button_label; ?>"></label>
				</div>
				<div class="design">
					<h3><?php _e('Screen Settings', 'pm-big-welcome'); ?></h3>
					<label><?php _e('Background Color', 'pm-big-welcome'); ?><br><input name="pm_biwe_options[screen][bgc][]" type="text" class="color-picker" value="<?php echo $bgc; ?>"></label>
					<label><?php _e('Text Color', 'pm-big-welcome'); ?><br><input name="pm_biwe_options[screen][txtc][]" type="text" class="color-picker" value="<?php echo $txtc; ?>"></label>
					<label><?php _e('Button Color', 'pm-big-welcome'); ?><br><input name="pm_biwe_options[screen][btnc][]" type="text" class="color-picker" value="<?php echo $btnc; ?>"></label>
					<label><?php _e('Animation', 'pm-big-welcome'); ?><br>
					<select class="animate-opts" name="pm_biwe_options[screen][anim][]">
					<?php foreach ($this->animopts as $aname => $avalue) { ?>
						<option value="<?php echo $avalue; ?>" <?php selected( $anim, $avalue, true ); ?>><?php echo $aname; ?></option>
					<?php }	?>
					</select></label>
					<label><?php _e('Show this on home page', 'pm-big-welcome'); ?> <select class="home" name="pm_biwe_options[screen][home][]">
						<option value="n" <?php selected( $home, 'n', true ); ?>>No</option>
						<option value="<?php echo $scrn_key; ?>" <?php selected( $home, $scrn_key, true ); ?>>Yes</option>
					</select></label>
					<label><?php _e('Cookie & don\'t show for:', 'pm-big-welcome') ?> <input type="text" class="cookie small-text" name="pm_biwe_options[screen][cookie][]" value="<?php echo $cookie; ?>"> days</label>
				</div>
			</div>
			<div class="item col content">
				<h3><?php _e('Content', 'pm-big-welcome'); ?></h3>
				<div id="pm_biwe_content_holder-<?php echo $scrn_key; ?>"></div>
				<?php
				wp_editor( $content, 'scrncontent-'.$scrn_key, array(
					'textarea_name' => 'pm_biwe_options[screen][content][]',
					'editor_class' => 'scrncontent',
					'editor_height' => '250px'
					) );
				?>
			</div>
		</li>
		<?php
	}
}