<?php
add_action( 'add_meta_boxes', 'pm_biwe_add_custom_box' );
function pm_biwe_add_custom_box() {
	// Gets all post types
	$post_types = get_post_types( array('public' => true) );
	//Removes attachments & other types from array to exclude
	unset($post_types['attachment'], $post_types['spp_lch_popups'] );

	// Load metabox for all post types except ones excluded above
	foreach ($post_types as $post_type) {
		add_meta_box( 
			'pm_biwe_mbox',
			__( PM_BIWE_PLUGIN_NAME , 'pm-big-welcome' ),
			'pm_biwe_display_box',
			$post_type, 'side' , 'default'
		);
	}
}

function pm_biwe_display_box( $post ) {
	$pm_biwe_opts = get_option( 'pm_biwe_options' );
	$pm_biwe_mbox_data = get_post_meta( $post->ID, '_pm_biwe_mbox_data', true);
  	$pm_biwe_screen = ( empty( $pm_biwe_opts['screen'] ) ) ? array() : $pm_biwe_opts['screen'] ;
	//print_r($pm_biwe_mbox_data);

		wp_nonce_field( plugin_basename( __FILE__ ), 'pm_biwe_metabox' );
		?>
	  <p>
	  	<label for="pm_biwe_show-<?php echo $post->ID; ?>"><?php _e( 'Display welcome screen', 'pm-big-welcome' ); ?></label><br>
	  	<select id="pm_biwe_show-<?php echo $post->ID; ?>" name="pm_biwe_show" >
  			<option value="no" <?php selected( $pm_biwe_mbox_data, '', true ); ?>><?php _e( 'No', 'pm-big-welcome' ); ?></option>
	  	<?php
  			foreach( $pm_biwe_screen as $screen_key => $screen ){ ?>
  				<option value="<?php echo $screen_key; ?>" <?php selected( $pm_biwe_mbox_data, $screen_key, true ); ?>><?php echo $screen['name'] ?></option>
  			<?php } ?>
  			</select></p>
	<?php
}

add_action( 'save_post', 'pm_biwe_save_postdata' );
function pm_biwe_save_postdata( $post_id ) {
  if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE ) 
      return;
  if ( !empty( $_POST['pm_biwe_metabox'] ) && !wp_verify_nonce( $_POST['pm_biwe_metabox'], plugin_basename( __FILE__ ) ) )
      return;
  if ( !empty($_POST['post_type']) && 'page' == $_POST['post_type'] ) 
  {
    if ( !current_user_can( 'edit_page', $post_id ) )
        return;
  }
  else
  {
    if ( !current_user_can( 'edit_post', $post_id ) )
        return;
  }
  $pm_biwe_opts = get_option( 'pm_biwe_options' );
  $saved_screen_keys = ( empty( $pm_biwe_opts['screen'] ) ) ? : array_keys( $pm_biwe_opts['screen'] );
	//array_push($saved_screen_keys, 'disabled');

  	// Gets all post types
	$post_types = get_post_types( array('public' => true) );
	//Removes attachments & other types from array to exclude
	unset($post_types['attachment'], $post_types['spp_lch_popups'] );

	// Save only for installed post types
	if ( in_array( get_post_type( $post_id ), $post_types )  ) {
	  	// Verify
	  	$valid_mbox_data = ( isset( $_POST['pm_biwe_show'] ) && is_numeric( $_POST['pm_biwe_show'] ) ) ? sanitize_key( $_POST['pm_biwe_show'] ) : 'no' ;
	  
		update_post_meta( $post_id, '_pm_biwe_mbox_data', $valid_mbox_data );
	}  
}