<?php 
add_action('admin_menu', 'pm_biwe_item_menu');
function pm_biwe_item_menu() {
	//add_submenu_page('edit.php?post_type=single_popover', 'Settings', 'Settings', 'edit_published_posts', 'bp_config', 'bp_config');
	global $pm_biwe_settings;

	// Options page with script/css loading on demand
	$pm_biwe_settings = add_options_page(PM_BIWE_PLUGIN_NAME.' Settings', PM_BIWE_PLUGIN_NAME, 'manage_options', 'pm_biwe_config', 'pm_biwe_config');
	add_action( 'load-'.$pm_biwe_settings, 'pm_biwe_adm_page_scripts' );
}

function pm_biwe_adm_page_scripts() {
	global $pm_biwe_settings;
	$screen = get_current_screen();
	$js_src = includes_url('js/tinymce/') . 'tinymce.min.js';
	$css_src = includes_url('css/') . 'editor.css';

	// Enqueue scripts if needed
	wp_enqueue_style( 'pm-biwe-admin', PM_BIWE_DIR.'css/admin.css', '', PM_BIWE_VERSION, 'all' );
	wp_enqueue_style('wp-color-picker');
	wp_register_style('tinymce_css', $css_src);
	wp_enqueue_style('tinymce_css');
	wp_enqueue_script( 'pm-biwe-admin', PM_BIWE_DIR.'js/admin.js', array('jquery', 'wp-color-picker', 'editor'), PM_BIWE_VERSION, true );
	//wp_enqueue_script( 'pm-biwe-arcode', PM_BIWE_DIR.'js/arcode.js', array('jquery', 'pm-biwe-admin'), PM_BIWE_VERSION, true );
	wp_enqueue_script( 'pm-biwe-tinymce', $js_src, array('jquery', 'pm-biwe-admin'), false, false );
	$ajax_data = array(
		'nonce' => wp_create_nonce( 'pm_biwe_get_editr' ),
		'is_admin' => is_admin()
		);
	wp_localize_script( 'pm-biwe-admin','pm_biwe_adm_ajax_obj', $ajax_data );

	/* hacky
	require_once(get_home_path() . WPINC . "/class-wp-editor.php");

	wp_enqueue_script('wplink');

	// hacky
	_WP_Editors::wp_link_dialog();
	*/
}

// WP Pointer Admin Tooltip - Make sure you use cookie to dismiss
add_action('admin_enqueue_scripts', 'pm_biwe_enqueue_pointer_scripts');
function pm_biwe_enqueue_pointer_scripts() {
	$dismissed = explode (',', get_user_meta (wp_get_current_user ()->ID, 'dismissed_wp_pointers', true));
    $not_in_array = !in_array ('pm_biwe_settings_dismiss', $dismissed);

    if( $not_in_array ) {
	    wp_enqueue_style('wp-pointer');
	    wp_enqueue_script('wp-pointer');
	    //hook the pointer 
	    add_action('admin_print_footer_scripts', 'pm_biwe_pointer_footer_scripts' );
	}
}
function pm_biwe_pointer_footer_scripts() {
    $pointer_content = '<h3>'.PM_BIWE_PLUGIN_NAME.'</h3>';
    $pointer_content .= '<p>'.__('Configure your settings here.', 'pm-quick-save').'</p>';
?>
   <script type="text/javascript">
   //<![CDATA[
   jQuery(document).ready( function($) {
    //jQuery selector to point to 
    $('#menu-settings').pointer({
        content: '<?php echo $pointer_content; ?>',
        position: 'top',
        close: function() {
            // This function is fired when you click the close button
            $.post (ajaxurl, {
		        pointer: 'pm_biwe_settings_dismiss',
		        action: 'dismiss-wp-pointer'
		    });
        }
      }).pointer('open');
   });
   //]]>
   </script>
<?php
}

add_action('admin_init', 'pm_biwe_settings_api_init');
function pm_biwe_settings_api_init() {
	//Add sections to add field later
	add_settings_section( 'pm_biwe_screen_section', __('Set Up Welcome Screens', 'pm-big-welcome'), 'pm_biwe_socialnetwork_settings', 'pm_biwe_settings_page' );

	// Add fields
	//add_settings_field( 'pm_biwe_screens', __('SettingsSection', 'pm-big-welcome'), 'pm_biwe_screens_callback', 'pm_biwe_settings_page', 'pm_biwe_screen_section' );

	//Register our setting
	register_setting( 
		'pm_biwe_settings_page',
		'pm_biwe_options',
		'pm_biwe_validate_settings' );
} //End pm_biwe_settings_api_init

// Settings Section Callbacks
function pm_biwe_socialnetwork_settings() {
	$pm_biwe_opts = get_option( 'pm_biwe_options' );
	$saved_screens = ( empty( $pm_biwe_opts ) ) ? '0' : $pm_biwe_opts['screen'];
	$animopts = array(
		__('Slide Out Up', 'pm-big-welcome') => 'slideOutUp',
		__('Bounce Out Up', 'pm-big-welcome') => 'bounceOutUp',
		__('Fade Out Up', 'pm-big-welcome') => 'fadeOutUp',
		__('Rotate Out', 'pm-big-welcome') => 'rotateOut',
		__('Zoom Out', 'pm-big-welcome') => 'zoomOut'
		);
	?>
	<ul class="screenlist">
		<?php
		$screen = new pmBiweRepeaterFields( $saved_screens, $animopts );
		echo $screen->settings_fields();
		?>
	</ul>
	<?php
	//echo '<pre>',print_r($pm_biwe_opts),'</pre>';
}

// Settings Field Callbacks
function pm_biwe_screens_callback() {
	?>
	<?php
}
// Validate input
function pm_biwe_validate_settings( $input ) {
	$pm_biwe_opts = get_option( 'pm_biwe_options' );
	$valid_input = '';

	$animopts = array(
		'slideOutUp',
		'bounceOutUp',
		'fadeOutUp',
		'rotateOut',
		'zoomOut'
		);

	$name = $input['screen']['name'];
	$ar_code = $input['screen']['ar_code'];
	$ar_name = $input['screen']['ar_name'];
	$ar_email = $input['screen']['ar_email'];
	$ar_url = $input['screen']['ar_url'];
	$ar_hidden = $input['screen']['ar_hidden'];
	$ar_name_label = $input['screen']['ar_name_label'];
	$ar_email_label = $input['screen']['ar_email_label'];
	$ar_button_label = $input['screen']['ar_button_label'];
	$bgc = $input['screen']['bgc'];
	$txtc = $input['screen']['txtc'];
	$btnc = $input['screen']['btnc'];
	$anim = $input['screen']['anim'];
	$content = $input['screen']['content'];
	$home = $input['screen']['home'];
	$cookie = $input['screen']['cookie'];

	$count = count( $name );
	
	//print_r($input);
	//echo "<hr>";

	for ($i=0; $i < $count ; $i++) {
		if( $name[$i] != '' ) {
			$valid_input['screen'][$i]['name'] = sanitize_text_field( $name[$i] );
			$valid_input['screen'][$i]['ar_code'] = stripslashes( $ar_code[$i] );
			$valid_input['screen'][$i]['ar_name'] = sanitize_text_field( $ar_name[$i] );
			$valid_input['screen'][$i]['ar_email'] = sanitize_text_field( $ar_email[$i] );
			$valid_input['screen'][$i]['ar_url'] = stripslashes( $ar_url[$i] );
			$valid_input['screen'][$i]['ar_hidden'] = stripslashes( $ar_hidden[$i] );
			$valid_input['screen'][$i]['ar_name_label'] = sanitize_text_field( $ar_name_label[$i] );
			$valid_input['screen'][$i]['ar_email_label'] = sanitize_text_field( $ar_email_label[$i] );
			$valid_input['screen'][$i]['ar_button_label'] = sanitize_text_field( $ar_button_label[$i] );
			$valid_input['screen'][$i]['home'] = ( is_numeric( $home[$i] ) ) ? $home[$i] : 'n' ;
			$valid_input['screen'][$i]['cookie'] = sanitize_text_field( $cookie[$i] );

			if( preg_match( '/^#[a-f0-9]{6}$/i', $bgc[$i] ) == '1' ) {
				$valid_input['screen'][$i]['bgc'] = sanitize_text_field( $bgc[$i] );
			}

			if( preg_match( '/^#[a-f0-9]{6}$/i', $txtc[$i] ) == '1' ) {
				$valid_input['screen'][$i]['txtc'] = sanitize_text_field( $txtc[$i] );
			}

			if( preg_match( '/^#[a-f0-9]{6}$/i', $btnc[$i] ) == '1' ) {
				$valid_input['screen'][$i]['btnc'] = sanitize_text_field( $btnc[$i] );
			}

			if( in_array( $anim[$i], $animopts ) ) {
				$valid_input['screen'][$i]['anim'] = stripslashes( $anim[$i] );
			}

			$valid_input['screen'][$i]['content'] = wp_kses_post( $content[$i] );

			if( is_numeric( $home[$i] ) ) {
				$valid_input['homescreen'] = $home[$i];
			}
		} 
	}
			//echo'<pre>',print_r($valid_input),'</pre>';
			//exit();

			return $valid_input;
}

// Callback for screen output
function pm_biwe_config(){

?>
<div class="wrap">
<h2><?php echo PM_BIWE_PLUGIN_NAME . ' ' . __('Settings', 'pm-big-welcome'); ?></h2>
<?php settings_errors( 'pm_biwe_options' ); ?>
<form method="POST" action="options.php">
<?php
	//pass slug name of page, also referred to in Settings API as option group name
	settings_fields( 'pm_biwe_settings_page' );	
	do_settings_sections( 'pm_biwe_settings_page' ); 	//pass slug name of page
	submit_button();
?>
</form>
  
</div>
<?php 
}